dnl $Id: config.m4 290089 2009-10-30 19:35:58Z rjcarroll $
dnl config.m4 for extension fuse

PHP_ARG_WITH(fuse, for fuse support,
[  --with-fuse             Include fuse support])

if test "$PHP_FUSE" != "no"; then
  SEARCH_PATH="/usr/local /usr"
  SEARCH_FOR="/include/fuse.h"
  if test -r $PHP_FUSE/$SEARCH_FOR; then
    FUSE_DIR=$PHP_FUSE
  else
    AC_MSG_CHECKING([for fuse files in default path])
    for i in $SEARCH_PATH ; do
      if test -r $i/$SEARCH_FOR; then
        FUSE_DIR=$i
        AC_MSG_RESULT(found in $i)
      fi
    done
  fi

  if test -z "$FUSE_DIR"; then
    AC_MSG_RESULT([not found])
    AC_MSG_ERROR([Please reinstall the fuse distribution])
  fi

  PHP_ADD_INCLUDE($FUSE_DIR/include)

  LIBNAME=fuse
  LIBSYMBOL=fuse_mount

  PHP_CHECK_LIBRARY($LIBNAME,$LIBSYMBOL,
  [
    PHP_ADD_LIBRARY_WITH_PATH($LIBNAME, $FUSE_DIR/lib, FUSE_SHARED_LIBADD)
    AC_DEFINE(HAVE_FUSELIB,1,[ ])
  ],[
    AC_MSG_ERROR([wrong fuse lib version or lib not found])
  ],[
    -L$FUSE_DIR/lib -lm -ldl
  ])

  PHP_SUBST(FUSE_SHARED_LIBADD)

  AC_DEFINE(FUSE_USE_VERSION,26,[ ])
  AC_DEFINE(_FILE_OFFSET_BITS,64,[ ])

  AC_MSG_CHECKING(target system)
  if echo "$target" | grep "darwin" > /dev/null; then
    AC_DEFINE(__Darwin__,1,[ ])
    AC_MSG_RESULT(Darwin)
  elif echo "$target" | grep "linux" > /dev/null; then
    AC_DEFINE(__Linux__,1,[ ])
    AC_DEFINE(_GNU_SOURCE,1,[ ])
    AC_MSG_RESULT(Linux)
  else
    AC_MSG_RESULT(other)
  fi

  PHP_NEW_EXTENSION(fuse, fuse.c, $ext_shared)

fi
